package merlin.filter;

import merlin.util.*;

/**
 * The interface of a filter. A filter takes a Pattern and modifies it 
 * to produce a new pattern.
 * Copyright (c) Stefan Hellkvist (see COPYRIGHT)
 * @author Stefan Hellkvist
 * @version 1.0
 */

public abstract class Filter
{
    
    /**
     * You apply a filter to a pattern and get a new pattern
     * @param p  The pattern to apply the filter on
     * @return A new Pattern
     */
    public abstract Pattern apply(Pattern p);
}
