package merlin.filter;

import merlin.util.*;
import java.awt.*;
import java.math.*;
import java.util.*;

/**
 * A smoothing filter. The character is smoothed to reduce
 * discretation errors
 * Copyright (c) Stefan Hellkvist (see COPYRIGHT)
 * @author Stefan Hellkvist
 * @version 1.0
 */

public class SmoothFilter extends Filter
{
    /** 
     * Default constructor
     */
    public SmoothFilter()
	{
	}

    /**
     * You apply a filter to a pattern and get a new pattern
     * @param p  The pattern to apply the filter on
     * @return A new Pattern
     */
    public Pattern apply(Pattern pat)
	{
	    Pattern pat2 = new Pattern();
	    for (Enumeration strokes = pat.strokes();
		 strokes.hasMoreElements();)
	    {
		Vector points = (Vector) strokes.nextElement();
		Vector newStroke = new Vector();
		for (int index = 0; index < points.size(); index++)
		{
		    if (index == 0 || index == points.size()-1)
			newStroke.addElement(points.elementAt(index));
		    else
		    {
			Point p1 = (Point) points.elementAt(index-1);
			Point p2 = (Point) points.elementAt(index);
			Point p3 = (Point) points.elementAt(index+1);
  			Point newp = new Point((p1.x + p2.x + p3.x)/3, 
					       (p1.y + p2.y + p3.y)/3);
			newStroke.addElement(newp);
		    }
		}
		pat2.addStroke(newStroke);
	    }
	    pat2.ascii = pat.ascii;
	    return pat2;	    
	}
}


