/** -------------------------------------------------------------------
  *      maintainer: Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * projects:
  *	- Jaugment II
  *       part: char-rec
  *	   used in release: current      used in version: current
  * -------------------------------------------------------------------
  * Copyright:   Copyright (c) 2000 by Marcus Wolschon <Suran@gmx.net>
  * -------------------------------------------------------------------
  * changes:
  * 0.0.1 (2001-02-16, Marcus Wolschon<Suran@gmx.net>)
  *       - created
  * -------------------------------------------------------------------
  * TODO:
  *       - implement jMerlin into this
  *       - find out from wich control we get the focus
  */
package jaugment2.charrec;

  //JDK
  //Swing
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
  //jmerlin
import Merlin;
import Merlin.RecogListener;
  //jAugment
import jaugment2.helpers.Logger;

/**
 * Small dockin for a character-recognition-input
 */
public class CharrecDockin extends JPanel implements RecogListener
{
 private static final boolean debug=true;
 public void characterRecognized(char c)
 { 
  if(debug)Logger.debug.println("DEBGU: [charrec] characterRecognized("+c+")");
  //TODO
  if(sentto != null)
    {
     KeyEvent k = new KeyEvent(this, 0, System.currentTimeMillis(),0 ,KeyEvent.VK_UNDEFINED, c);
     if(debug)Logger.debug.println("DEBGU: [charrec] characterRecognized("+c+") dispatching to a \""+sentto.getClass().toString()+"\"");
     sentto.dispatchEvent(k);
    }
 };

  private Object proxy = null;
  private Component sentto = null;

  public CharrecDockin(Object p)
  {
   this.proxy = p;
    try
    {
      jbInit();
    }
    catch(Exception e)
    {
      e.printStackTrace(Logger.err);
    }
  }

 public void setFont(Font f)
 {
  if(f == null)
    return;
/*  if(jLabel1 == null)
    return;
  Font f2 = new Font(f.getFontName(), f.getStyle(), (int)(f.getSize()*0.75));
*/  super.setFont(f);
/*  jLabel1.setFont(f2);*/
 }

 private Merlin merlin = null;

  private void jbInit() throws Exception
  {
    this.setMaximumSize(new Dimension(109, 30));
    this.setMinimumSize(new Dimension(59, 19));
    this.setPreferredSize(new Dimension(89, 19));

    this.setLayout(new BorderLayout());
    this.setBackground(Color.white);
    this.merlin = new Merlin();
    this.add(merlin, BorderLayout.CENTER);
    this.merlin.addRecogListener(this);
    this.addFocusListener(new FocusListener()
      { public void focusGained(FocusEvent evt)
        {
         sentto = (Component)evt.getSource();
         if(debug)Logger.debug.println("DEBUG: [charrec] focusGained from a \""+sentto.getClass().toString()+"\"");
        };
        public void focusLost(FocusEvent evt){};
      });
    
  }

}
